// ONSBJ14.pde
// On Ne Se Baigne Jamais
//
// ONSBJ11 adapte pour Raspberry + AudioPlayer remplace par Sampler 
//
// Gerard Paresys  Guykayser
// 28 12 2018
//
// Processing 2 3
//   + library minim
//

import ddf.minim.*;
// import ddf.minim.spi.*; // for AudioRecordingStream inutile?
import ddf.minim.ugens.*;

String[] NomFichierAudio = {
  "ONSBJ_alexei.wav", 
  "ONSBJ_anna.wav"
};

String[] NomFichierXML = {
  "ONSBJ_alexei-mergeGG2.xml", 
  "ONSBJ_anna-mergeGG2.xml"
};
int maxVoices = 4; // the maximum number of voices for Sampler
int NVoix = 2; // 2 Voix
int FacteurMax = 10; // 10 sous MacOS // 3 max sous Raspbian
float NiveauSonore = 1.0 / FacteurMax; // pour ne pas saturer

int NombreCouche = 5; 
int Couche = 3;  // 0 .. 4
boolean AfficheMenu = true; // false
int Facteur = FacteurMax;
boolean Alexei = false; // false
boolean Anna = true;
boolean Alea = false;

int Voix;  // 0 .. 1
PFont FontExo2;
float hhh, LimniMini, LimniMaxi;
PImage ImageFond;

// AudioPlayer[] LecteurAudio = new AudioPlayer[NVoix * FacteurMax];
Minim MonMinim;
// FilePlayer[] LecteurAudio = new FilePlayer[NVoix * FacteurMax];
Sampler[] LecteurAudio = new Sampler[NVoix * FacteurMax];
AudioOutput Sortie;


int Temps, TempsPause;
int[] TempsPaus = new int[NVoix]; //ms
int[] TempsVoix = new int[NVoix * FacteurMax]; //ms
int[] IndexXML = new int[NVoix * FacteurMax]; 
boolean Initialisation = true;


void setup() {
  size(600, 1024);
  fill(0);
  FontExo2 = loadFont("Exo-Bold-200.vlw");
  textFont(FontExo2);
  // smooth();
  ImageFond = loadImage("limniraspberry.png");
  cocosetup();

  println("NiveauSonore = " + NiveauSonore);

  for (Voix = 0; Voix < NVoix; Voix++) Ouverture(NomFichierXML[Voix], Voix);

  MonMinim = new Minim(this);
  // MonMinim.debugOn();
  // Sortie = MonMinim.getLineOut(); // get a line out from Minim. 
  Sortie = MonMinim.getLineOut(Minim.MONO, 2048);

  for (Voix = 0; Voix < NVoix; Voix++) {
    if (loadStrings(NomFichierAudio[Voix]) == null) { 
      println("9 Le fichier " + NomFichierAudio + " n'existe pas");
      // Probleme = true;
    } else {
      println("Ouverture de Voix " + Voix + "   " + NomFichierAudio[Voix]);
      for (int Fac = 0; Fac < FacteurMax; Fac++) {
        // LecteurAudio[Voix + (2 *  Fac)] = MonMinim.loadFile(NomFichierAudio[Voix], 2048);
        // LecteurAudio[Voix + (2 *  Fac)] = new FilePlayer( MonMinim.loadFileStream(NomFichierAudio[Voix]));
        LecteurAudio[Voix + (2 *  Fac)] = new Sampler(NomFichierAudio[Voix], maxVoices, MonMinim);
        LecteurAudio[Voix + (2 *  Fac)].amplitude.setLastValue(NiveauSonore); 
        LecteurAudio[Voix + (2 *  Fac)].patch(Sortie); // patch the file player to the output
        println("LecteurAudio[" + (Voix + (2 *  Fac)) + "]");
      }
    }
  }

  noStroke();
  // frameRate(30);
  Initialisation = true;
  println("Fin setup()");
}

void draw() {
  if (Initialisation) {
    RAZ();
    Initialisation = false;
  } else {
    CalculIndiceLimni();
    for (Voix = 0; Voix < NVoix; Voix++) {
      if (((Voix == 0) && Alexei) || ((Voix == 1) && Anna)) {
        if (Alea) {
          for (int Fac = 0; Fac < Facteur; Fac++) {
            Temps = millis() - TempsPause; // ms
            if (Temps > TempsVoix[Voix + (2 *  Fac)]) {
              // LecteurAudio[Voix].pause(); //
              IndexXML[Voix + (2 *  Fac)] = int(random(0, XMLTier[Voix][Couche].length));
              XML kid1 = XMLTier[Voix][Couche][IndexXML[Voix + (2 *  Fac)]];
              float xmin = 1000 * kid1.getFloat("xmin"); // ms
              float xmax = 1000 * kid1.getFloat("xmax"); // ms
              String Content1 = kid1.getContent();
              if (AfficheMenu) println("Voix+(2*Fac)=" + (Voix + (2 *  Fac)) + "  " + IndexXML[Voix+(2* Fac)] + "  " + Content1 + "   Temps = " + Temps + "   TempsVoix[Voix+(2* Fac)] = " + TempsVoix[Voix+(2* Fac)] + "   xmin = " + xmin + "   xmax = " + xmax + "   IndexXML[" + (Voix+(2*Fac)) + "] = " + IndexXML[Voix+(2*Fac)]);
              // if (Temps > xmin) {
              // fill(255, 150); // semi-transparent white //(255, 50)
              // rect(0, 0, width, height);
              image(ImageFond, 0, 0);
              textSize(200);
              fill(255, 0, 0);
              textAlign(CENTER, CENTER);
              text(Content1, width/2, -81 +  height/2);
              // if ((Voix == 0) && Alexei) LecteurAudio[Voix + (2 *  Fac)].play(int(xmin));
              // if ((Voix == 1) && Anna) LecteurAudio[Voix + (2 *  Fac)].play(int(xmin));
              if (((Voix == 0) && Alexei)||((Voix == 1) && Anna)) {
                LecteurAudio[Voix + (2 *  Fac)].begin.setLastValue( 44.1 * xmin ); // samples
                LecteurAudio[Voix + (2 *  Fac)].trigger();
              }
              TempsVoix[Voix + (2 *  Fac)] = Temps + int(xmax-xmin);
            }
          }
          Facteur = FacteurMax * (Limni[IndiceLimni] - 800) / 3000;
          if (Facteur < 1) Facteur = 1;
          if (Facteur > FacteurMax) Facteur = FacteurMax;
          // println("Facteur = " + Facteur);
        } else {
          Temps = millis() - TempsPaus[Voix]; // ms
          if (Temps > TempsVoix[Voix]) {
            if (IndexXML[Voix] < XMLTier[Voix][Couche].length - 1) {
              IndexXML[Voix] = IndexXML[Voix] + 1;
              XML kid1 = XMLTier[Voix][Couche][IndexXML[Voix]];
              float xmin = 1000 * kid1.getFloat("xmin"); // ms
              float xmax = 1000 * kid1.getFloat("xmax"); // ms
              String Content1 = kid1.getContent();
              if (AfficheMenu) println("Voix " + (Voix) + "  " + IndexXML[Voix] + "  " + Content1 + "   Temps = " + Temps + "   TempsVoix[Voix] = " + TempsVoix[Voix] + "   xmin = " + xmin + "   xmax = " + xmax + "   IndexXML[" + (Voix) + "] = " + IndexXML[Voix]);
              // if (Temps > xmin) {
              // fill(255, 150); // semi-transparent white //(255, 50)
              // rect(0, 0, width, height);
              image(ImageFond, 0, 0);
              textSize(200);
              fill(255, 0, 0);
              textAlign(CENTER, CENTER);
              text(Content1, width/2, -81 +  height/2);
              // if ((Voix == 0) && Alexei) LecteurAudio[Voix].play(int(xmin));
              TempsVoix[Voix] = int(xmax);
            } else {
              if ((Voix == 0) && Alexei) Init();
              if ((Voix == 1) && Anna) Init();
            }
          }
        }
      } 
      if (!Alexei && !Anna) image(ImageFond, 0, 0);
    }

    cocodraw();

    fill(255);
    textSize(67);
    textAlign(CENTER, BASELINE);
    text(Limni[IndiceLimni] / 10, width/2, hhh+50); // cm d'eau
    Menu();
  }
}
void keyPressed() {
  if (key == 'n' || key == 'N') Anna = !Anna;
  if (key == 'x' || key == 'X') Alexei = !Alexei;
  if (key == '1') Couche = 0;
  if (key == '2') Couche = 1;
  if (key == '3') Couche = 2;
  if (key == '4') Couche = 3;
  if (key == '5') Couche = 4;
  if (key == 'a' || key == 'A') Alea = !Alea;
  if (key == 'm' || key == 'M') AfficheMenu = !AfficheMenu;
  println("Anna = " + Anna + "    Alexei = " + Alexei + "    Alea = " + Alea);
  RAZ();
}

void Init() {
  println("Init " + Voix +  " ------");
  IndexXML [Voix] = -1; // Modif ONSBJ11
  TempsVoix[Voix] = 0;
  TempsPaus[Voix] = millis();
  // LecteurAudio[Voix].play(0);
  LecteurAudio[Voix].trigger();
}

void RAZ() {
  println("RAZ -----------------------------------------------");
  for (int Voi = 0; Voi < 2; Voi = Voi+1) {
    for (int Fac = 0; Fac < FacteurMax; Fac++) {
      IndexXML [Voi + (2 *  Fac)] = -1;
      TempsVoix[Voi + (2 *  Fac)] =  0;
    }
  }
  TempsPause = millis();
}

void Menu() {
  if (AfficheMenu) {
    textSize(14);
    textAlign(LEFT, TOP);
    fill(0, 0, 200);
    int x = 450;
    int y = 1;
    text("N Anna", x, y++*16);
    text("X Alexei", x, y++*16);
    text(" ", x, y++*16);
    for (int i = 0; i < NombreCouche; i = i+1) text(i+1 + " " + TierName[i], x, y++*16);
    text(" ", x, y++*16);
    text("A Aléatoire", x, y++*16);
    text(" ", x, y++*16);
    // text("Espace Début audio", x, y++*16);
    text("Echap Stop", x, y++*16);
    text("M Menu", x, y++*16);
    text(" ", x, y++*16);
    fill(255);
    rect(x - 3, y*16 - 4, 100, 15);
    fill(0, 0, 200);
    text(float(Temps) / 1000 + " sec", x, y++*16);
  }
}
